/*  This file is a part of the program DNetStats.
    DNetStats a linux qt application to monitor network and initiate 
    autoshutdown when connection is cut or idle.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
#include "dialogimpl.h"
//
DialogImpl::DialogImpl( QWidget * parent, Qt::WFlags f) 
	: QDialog(parent, f)
{    count=0;
	//f |=Qt::WindowSystemMenuHint | Qt::WindowMinimizeButtonHint ;
	setupUi(this);	
        buf1=1;
        buf2=1;
        startflag=false;
        ubuf1=1;
        ubuf2=1;
	idlecounter=0;
	countstr="unknown";
	pathstr="audio.wav";
	systraymsg=true;
        ishidden=false;
        lastsessmonth="unknown";
        x1=0;y1=0;x2=0;y2=50;
        row=0;column=0,rowcount=1;
        tablenet->insertRow(2);
           totaldown=0;
           prevmonthdown=0;
           lastsess=0;
           shutinit=false;
            fpos=0;
           monthdown=0;
           sessdown=0;
           nspeed=0;
           shutreason="unknown";
           tmpdouble=0;
           

         //
	connect(bstart, SIGNAL(clicked()), this, SLOT(addClick()));
	connect(bstop, SIGNAL(clicked()), this, SLOT(addShut()));
	connect(bexit, SIGNAL(clicked()), this, SLOT(addExit()));
        connect(bsave, SIGNAL(clicked()), this, SLOT(addSave()));
        connect(tabwid, SIGNAL(currentChanged(int)), this, SLOT(tabactive(int)));
	connect(breset, SIGNAL(clicked()), this, SLOT(addReset()));
        connect(bresetcount, SIGNAL(clicked()), this, SLOT(addResetCount()));
        connect(bpkill, SIGNAL(clicked()), this, SLOT(addPkill()));
	connect(&threadA, SIGNAL(conok()), this, SLOT(chgconok()));
        connect(&threadA, SIGNAL(concut()), this, SLOT(chgconcut()));
        connect(tablenet, SIGNAL(itemClicked ( QTableWidgetItem *  )), this, SLOT(itemclicked(QTableWidgetItem * )));
        //
        connect(&nthread, SIGNAL(availlist(const QStringList &)), this, SLOT(ntmap_refresh(const QStringList &)));
        connect(&nthread, SIGNAL(fileend()), this, SLOT(fileendslot()));
        //
         sysv=system("touch .spdchk.ld");
         sysv=system("touch .tfdmp.ld");
	 //
	 create_msg_box();
	 trayicon = new QSystemTrayIcon(this);
     create_sys_tray();
	 //


         QFile file(".savefile.ld");
     if (!file.open(QIODevice::ReadOnly | QIODevice::Text))
     {
                sysv=system("touch .savefile.ld");
		cerr<<"\ncan't find savefile,creating one\n";
        }
	QTextStream in(&file);
	  if(!in.atEnd())
	  {
          spinBox->setValue(in.readLine(8).toUInt(&ok,10));
          sbidle->setValue(in.readLine(8).toUInt(&ok,10));
          sbidlespeed->setValue(in.readLine(8).toUInt(&ok,10));
	  comboBox->setCurrentIndex(in.readLine(8).toInt(&ok,10));
          sbinterval->setValue(in.readLine(8).toUInt(&ok,10));
	  lepath->setText(in.readLine(100));
          cbminim->setChecked(in.readLine(8).toUInt(&ok,10));
          cbauto->setChecked(in.readLine(8).toUInt(&ok,10));
      }
	 file.close();

           get_log();// get the log file info
    	 gView->setScene(&scene);
	 mfont=QFont ();
	 mfont.setPointSize(8);	
	//line2=QLineF(0,100,250,100 ); 
	 gView->setAlignment((Qt::AlignLeft | Qt::AlignBottom));
	 scene.setSceneRect(0,0,160,50);	 
	 //QRadialGradient gradient(0, 0, 10);
         // gradient.setSpread(QGradient::RepeatSpread);
         gviewshow();

         threadA.chkstring=QString("ifconfig %1 >.spdchk.ld 2>/dev/null")
             .arg(comboBox->currentText());
         if(cbminim->isChecked())
         {

            //
            trayicon->showMessage("Warning","DNetStats is Minimised",QSystemTrayIcon::Warning,20);
            trayicon->showMessage("Information","DNetStats is Minimised",QSystemTrayIcon::Information,2000);
             ishidden=true;
             this->hide();
        }
         else
              this->showNormal();
         if(cbauto->isChecked())
             addClick();

         show_stat();


        set_log();
     }

//
void DialogImpl::addClick()
{
 count=0;
 startflag=true;
 threadA.chkstring=QString("ifconfig %1 >.spdchk.ld 2>/dev/null")
             .arg(comboBox->currentText());
 
 if(!threadA.isRunning())
 {
  	//

  threadA.interval=sbinterval->value();	
  tedit->setText("Checking connection");  
  threadA.start();
  
  lcpstatus->setText("Started");
  bstart->setEnabled(false);
  bstop->setEnabled(true);
  startAction->setDisabled(true);
  stopAction->setEnabled(true);
 connframe->setDisabled(true);
  
 }
 
}


void DialogImpl::addShut()
{ 

 tedit->setText("Checkcon stopped!");
 lcpstatus->setText("Stopped"); 
//
    icon =QIcon(":/icons/109.ico");
    trayicon->setIcon(icon);
    trayicon->show();
     systraymsg=true;

  
 //
 threadA.terminate();
 threadA.wait();
 sthread.terminate();
	sthread.wait();
 bstart->setEnabled(true);
 bstop->setEnabled(false);
 startAction->setEnabled(true);
  stopAction->setEnabled(false);
 connframe->setEnabled(true);

}

void DialogImpl::addExit()
{
   
    threadA.terminate(); 
    threadA.wait();
     sthread.terminate();
	sthread.wait();
        nthread.terminate();
        nthread.wait();
        sysv=system("rm -f .spdchk.ld");
        sysv=system("rm -f .tfdmp.ld");
	
	

    exit(0);
 
}
void DialogImpl::addSave()
{
        QFile file(".savefile.ld");
     if (!file.open(QIODevice::WriteOnly | QIODevice::Text))
     {
        sysv=system("touch .savefile.ld");
		cerr<<"\ncan't find savefile,creating one\n";
     }
     QTextStream out(&file);
     out<<spinBox->text()<<"\n";
     out<<sbidle->text()<<"\n";
     out<<sbidlespeed->text()<<"\n";
     out<<comboBox->currentIndex()<<"\n";
     out<<sbinterval->text()<<"\n"; 
     out<<lepath->text()<<"\n"; 
     out<<cbminim->isChecked()<<"\n";
     out<<cbauto->isChecked()<<"\n";

     
     file.close();
}
void DialogImpl::addReset()
{
			spinBox->setValue(20);
	  sbidle->setValue(2);
	  sbidlespeed->setValue(5);
	  sbinterval->setValue(2);
}
	
void DialogImpl::chgconok()
{	

        systraymsg=true;
	if(sthread.isRunning())
        {
			sthread.terminate();
	       sthread.wait();
         }

         lstatus->setText("Connected");
	count=count+threadA.interval; //counting time
        tedit->setText("<i>Interface UP!</i>");
        tedit->append(QString("Local IP: ").append(threadA.ipAddr));
         
                icon =QIcon(":/icons/109-2.ico");
    trayicon->setIcon(icon);
    trayicon->show();
	//
	QPen pen(Qt::green,1);
    line3=QLineF(x1,y1,x2,y2 ); 
    
    gView->show();
    if(x1>=138)
    {
    	x1=0;
    	scene.clear();
    	gviewshow();
    }
    x1=x1+1;
    x2=x1;
    y1=2*(25-((nspeed/8)%25));
    scene.addLine(line3,pen);
     countstr=QString("%1h:%2m:%3s")
             .arg((count/3600), 0, 10)
             .arg(((count/60)%60), 0, 10)
             .arg((count%60), 0, 10);
	 //
    buf1=threadA.rxBytes.toULong(&ok,10);
    rvdown=buf1;  
    if(startflag)
    {
        buf2 = buf1;
        startflag=false;
    }

    ubuf1=threadA.txBytes.toULong(&ok,10);
    nspeed=((buf1-buf2)*8)/(threadA.interval*1024);
    ucspeed=((ubuf1-ubuf2)*8)/(threadA.interval*1024);
    if((nspeed<=0)||(nspeed>=1000000))
        nspeed=0;
    else
    sessdown=sessdown+(buf1-buf2);
    cspeed=nspeed;
    lcdnum->display(cspeed);
    if(cbimusic->isChecked()||cbidle->isChecked())
    {
          if(cspeed<(sbidlespeed->value()))
	      {	idlecounter++; 	}
          else
              { idlecounter=0; }
          if((idlecounter*threadA.interval) >= (sbidle->value()*60))//when idlecounter exceeds the time shutdown takes place
	       {
                 if(cbimusic->isChecked())
                    {
                    pathstr=QString("xterm -e 'aplay %1'")
                            .arg(lepath->text());
                    sysv=system(pathstr.toLocal8Bit().constData());


                    }
                 cbimusic->setChecked(false);
                if(cbidle->isChecked())
                 {initshut("connection idle");
                    cbidle->setChecked(false);}

               }
     }
    else
        idlecounter=0;
    buf2=buf1;
    ubuf2=ubuf1;
    lvdown=sessdown;

    vdown=lvdown/(1024*1024);
    //log



    show_stat();
        //
    ldown->setText((QString::number(vdown,'f',2)).append(" MB"));
    traystr=QString("DNetStats\nU: %1kbps   D: %2kbps")
             .arg((ucspeed), 0, 10)
             .arg((nspeed), 0, 10);

    trayicon->setToolTip(traystr);
    lcount->setText(countstr);

set_log();
}
void DialogImpl::chgconcut()
{    
    gviewshow();
      lstatus->setText("Not Connected");
    tedit->setText("Connection Unavailable!");
    trayicon->setToolTip("DNetStats");
    if(systraymsg)
        trayicon->showMessage("Warning","connection unavailable",QSystemTrayIcon::Warning,2000);
        systraymsg=false;
    icon =QIcon(":/icons/109.ico");
    trayicon->setIcon(icon);
    trayicon->show();
        //bstart->setEnabled(true);
    if(cbmusic->isChecked())
        {
                pathstr=QString("xterm -e 'aplay %1'")
                            .arg(lepath->text());			
        sysv=system(pathstr.toLocal8Bit().constData());
         cbmusic->setChecked(false);
        }
	if(cbshut->isChecked())
		
	{   
	 initshut("connection cut");
	}

	 bstop->setEnabled(true);
			
}
void DialogImpl::gviewshow()
{	 QPen pen(Qt::gray,1);
	 pen.setStyle(Qt::DotLine);
	 pen.setCapStyle(Qt::RoundCap);
	 line1=QLineF(0,13.5,180,13.5 );
         scene.addLine(line1,pen);
         line4=QLineF(0,25.5,180,25.5 );
         scene.addLine(line4,pen);
         line5=QLineF(0,37.5,180,37.5);
         scene.addLine(line5,pen);
	  //scene.addText((QString::number((cspeed/8),'f',0)).append("KB/s"),mfont);
	 QRadialGradient gradient(100, 100, 150, 50, 50);
     gradient.setColorAt(0, QColor::fromRgbF(0, 0, 0, 1));
     gradient.setColorAt(1, QColor::fromRgbF(0, 0, 0, 0));
     gradient.setCenter(0,0);
     scene.setBackgroundBrush(gradient);
     scene.setForegroundBrush(QBrush(Qt::gray, Qt::Dense6Pattern));        
	 gView->show();
}
void DialogImpl::initshut(QString reason="unknown")
{
        shutreason=reason;
          shutinit=true;
	tedit->append("Checkcon stopped for shutdown!");
	    threadA.terminate();
	     threadA.wait();
             lcpstatus->setText("Stopped");
            //Saving the log
	    tedit->append("Saving to log chklog.txt");
            set_log();
            shutinit=false;
	// 
	
	sthread.shuttime=spinBox->value();
	sstr=QString("The System is going down in %1 second.!!!")
             .arg(sthread.shuttime, 0, 10);
	tedit->append(sstr);
        tedit->append("You must be root!");
	sthread.start(); 
	msgBox.setText(QString(" <h3>The system is going down in %1 seconds         </h3>").arg((sthread.shuttime), 0, 10));
	msgBox.setInformativeText(QString("<i>Reason:%1. %2</i>").arg(reason,QString("Press 'Abort' button to cancel.")));
	ret=msgBox.exec();	 
	if(ret==262144)
      {
      	sthread.terminate();
        sthread.wait();
        tedit->clear();
        bstop->setDisabled(true);
        bstart->setEnabled(true);
        //tab_2->setEnabledtedit->clear();(true);
        connframe->setEnabled(true);
     }
     else if(ret==1024)
        {
            bstop->setDisabled(true);
            bstart->setEnabled(true);
           connframe->setEnabled(true);
           tedit->setText("going down");
         sysv=system("init 0");
     	 idlecounter=0;
    	}
}

void DialogImpl::tray_icon_click(QSystemTrayIcon::ActivationReason areason)
{
  switch (areason) {
     case QSystemTrayIcon::Trigger:  
     if (this->isHidden())
    {
          

        setVisible(true);
        activateWindow();
        QWidget::setWindowState(Qt::WindowActive);
        ishidden=false;
         this->show();
    }
    else
    {        

        this->setVisible(false);
        ishidden=true;
        this->hide();
    }
    break;
     case QSystemTrayIcon::DoubleClick:
          break;
     case QSystemTrayIcon::MiddleClick:         
         break;
     default:
         ;
     }

    
}

void DialogImpl::closeEvent(QCloseEvent *event)
{
    threadA.stop();    
    threadA.wait();
    sthread.terminate();
    sthread.wait();  
    nthread.terminate();
    nthread.wait();
    sysv=system("rm -f .spdchk.ld");
    sysv=system("rm -f .tfdmp.ld");
    event->accept();     
    
}
void DialogImpl::create_msg_box()
{
	msgBox.setTextFormat(Qt::RichText);   
        msgBox.setStandardButtons(QMessageBox::Ok | QMessageBox::Abort);
 	msgBox.setDefaultButton(QMessageBox::Abort);
 	msgBox.setWindowTitle("Shutdown");
 	msgBox.setIcon(QMessageBox::Warning);
        msg2Box.setTextFormat(Qt::RichText);
        msg2Box.setStandardButtons(QMessageBox::Ok | QMessageBox::Cancel);
        msg2Box.setDefaultButton(QMessageBox::Cancel);
        msg2Box.setWindowTitle("Kill Process");
        msg2Box.setIcon(QMessageBox::Warning);
}

void DialogImpl:: create_sys_tray()
{
	icon =QIcon(":/icons/109.ico");
 if(icon.isNull())
 {
 	tedit->setText("icon null");
 }
//
    
    connect(trayicon, SIGNAL(activated(QSystemTrayIcon::ActivationReason)), this, SLOT(tray_icon_click(QSystemTrayIcon::ActivationReason)));
    stmenu = new QMenu(this);
    //
     startAction = new QAction(tr("&Start"), this);
     startAction->setIcon(QIcon(":/icons/cache.png"));
     connect(startAction, SIGNAL(triggered()), this, SLOT(addClick()));

     stopAction = new QAction(tr("Sto&p"), this);
     stopAction->setIcon(QIcon(":/icons/energy.png"));
     connect(stopAction, SIGNAL(triggered()), this, SLOT(addShut()));

     minimizeAction = new QAction(tr("Mi&nimize"), this);
     minimizeAction->setIcon(QIcon(":/icons/minim.ico"));
     connect(minimizeAction, SIGNAL(triggered()), this, SLOT(hide()));

     maximizeAction = new QAction(tr("M&aximise"), this);
     maximizeAction->setIcon(QIcon(":/icons/maxim.ico"));
     connect(maximizeAction, SIGNAL(triggered()), this, SLOT(showNormal()));

     quitAction = new QAction(tr("&Quit"), this);
     quitAction->setIcon(QIcon(":/icons/quit.ico"));
    connect(quitAction, SIGNAL(triggered()), this, SLOT(addExit()));
   //
     if(!QSystemTrayIcon::isSystemTrayAvailable())
     {
     	cout<<"tray icon not found";
     	
     }
       stmenu->addAction(startAction);
     stmenu->addAction(stopAction);
     stmenu->addAction(maximizeAction);
     stmenu->addAction(minimizeAction);    
     stmenu->addSeparator();
     stmenu->addAction(quitAction);
     	trayicon->setContextMenu(stmenu);
         trayicon->setIcon(icon);
     	//trayicon->setVisible(true);
     	//trayicon->setToolTip("DNetStats");
     	
        setWindowIcon(icon);    	 
    	trayicon->show();
    
	 //  
}
void DialogImpl::tabactive(int index)
{
    if(index==1)
    {
        tablenet->clearContents();
        tablenet->removeRow(tablenet->rowCount());
        leprocess->clear();
        row=0;
        rowcount=1;
        nthread.start();

    }
    else
    {
        nthread.terminate();
        nthread.wait();
    }


}
//
void DialogImpl::ntmap_refresh(const QStringList list)
{

           tablenet->setRowCount(row+1);
          // cout<< list.at(6).toLocal8Bit().constData() << endl;
           newItem = new QTableWidgetItem(list.at(6),0);
           tablenet->setItem(row, column, newItem);
           newItem = new QTableWidgetItem(list.at(3),0);
           tablenet->setItem(row, column+1, newItem);
           newItem = new QTableWidgetItem(list.at(4),0);
           tablenet->setItem(row, column+2, newItem);
           row++;
   if(!this->isHidden())
           this->show();
 }

void DialogImpl::fileendslot()
{
        tablenet->removeRow(tablenet->rowCount());
        tablenet->clearContents();
        row=0;
        rowcount=1;
}

void DialogImpl::itemclicked(QTableWidgetItem * itemclick )
{
itemlist=tablenet->selectedItems();
leprocess->setText(itemlist.at(0)->text());

}
void DialogImpl::addPkill()
{
QString pkstr=leprocess->text().section('/',0,0);
if(!pkstr.isEmpty())
{
msg2Box.setText(QString(" <h4>Are you sure to kill the process %1         </h4>").arg(leprocess->text()));
msg2Box.setInformativeText("<i>Warning: Kill a process only if it is unwanted! </i>");
ret2=msg2Box.exec();
 //leprocess->setText(ret2);
         if(ret2==1024)
        {
            pkstr=QString("kill ").append(pkstr);           
            sysv=system(pkstr.toLocal8Bit().constData());
        }
         else
             return;
}
}
void DialogImpl::get_log()
{
    QFile file4(".chklog.txt");

         if (!file4.open(QIODevice::ReadOnly | QIODevice::Text))
     {
           sysv=system("touch .chklog.txt");

           // QFile file1(dir.filePath(".chklog.txt"));

     }
           QTextStream in4(&file4);

           if(!in4.atEnd())
           totaldown=in4.readLine(50).toULong(&ok,10);
           if(!in4.atEnd())
           prevmonthdown=in4.readLine(50).toULong(&ok,10);
           if(!in4.atEnd())
           monthdown=in4.readLine(50).toULong(&ok,10);
           if(!in4.atEnd())
           lastsess=in4.readLine(50).toULong(&ok,10);
            fpos=in4.pos();
           if(!in4.atEnd())
           lastsessmonth=in4.readLine(40);
            cdate=QDate::currentDate();
           if(cdate.toString("MMMM")!=lastsessmonth)
           {
           //prevmonthdown=monthdown;
           //monthdown=0;
           //in4.seek(fpos);
           //in4<<cdate.toString("MMMM")<<"\n";
           }
           if(!in4.atEnd())
           {
           telog->setText(in4.readLine(50));
           telog->append(in4.readLine(50));
           telog->append(in4.readLine(50));
           telog->append(in4.readLine(50));
           }
           file4.close();
}
void DialogImpl::set_log()
{
    QFile file3(".chklog.txt");

       if(!file3.open(QIODevice::ReadWrite | QIODevice::Text))
        {
           sysv=system("touch .chklog.txt");

           // QFile file1(dir.filePath("chklog.txt"));

        }
         cdate=QDate::currentDate();
           if(cdate.toString("MMMM")!=lastsessmonth)
           {
           prevmonthdown=monthdown;
           monthdown=0;
           lastsessmonth=cdate.toString("MMMM");
           //in4.seek(fpos);
           //in4<<cdate.toString("MMMM")<<"\n";
           }
           QTextStream in3(&file3);
           in3<<totaldown+sessdown<<"\n";
           in3<<prevmonthdown<<"\n";
           in3<<monthdown+sessdown<<"\n";
           in3<<sessdown<<"\n";
           in3<<cdate.toString("MMMM")<<"\n";
           if(shutinit)
           {
           in3<<"The connection lasted:- "<<countstr<<"\n";
           in3<<"Reason:- "<<shutreason<<"\n";
           in3<<"Downloaded:- "<<(QString::number(vdown,'f',2)).append(" MB")<<"\n";
           ctime= QDateTime::currentDateTime();
           in3<<"Time:- "<<ctime.toString("h:m:s ap ddd dd MMMM yyyy")<<"\n";
           }
           shutinit=false;
           file3.close();

}


void DialogImpl::addResetCount()
{

        msg3Box.setTextFormat(Qt::RichText);
        msg3Box.setStandardButtons(QMessageBox::Ok | QMessageBox::Cancel);
        msg3Box.setDefaultButton(QMessageBox::Cancel);
        msg3Box.setWindowTitle("Reset Counters!");
        msg3Box.setIcon(QMessageBox::Warning);
        msg3Box.setText(QString(" <h4>Are you sure to reset the counters! </h4>"));
        msg3Box.setInformativeText("<h6><i>Info:This resets month counters.(Delete '.chklog.txt ' to reset all logs and stats) </i></h6>");
        ret=msg3Box.exec();
        if(ret==262144)
      {

      }
     else if(ret==1024)
        {
         prevmonthdown=0;
         monthdown=0;
         sessdown=0;
          set_log();

           show_stat();
        }

}
void DialogImpl::show_stat()
{

    testat->clear();
        if(((totaldown+sessdown)/(1024*1024))<=999)
         {
            tmpdouble=totaldown+sessdown;
            tmpdouble=tmpdouble/(1024*1024);
             testat->append(QString("Total Download :%1 MB")
                            .arg(tmpdouble,0,'f',2));
         }
         else
         {
             tmpdouble=totaldown+sessdown;
             tmpdouble=tmpdouble/(1024*1024*1024);
             testat->append(QString("Total Download :%1 GB")
                            .arg(tmpdouble, 0,'f',2));
         }
        if(((prevmonthdown)/(1024*1024))<=999)
         {
                tmpdouble=prevmonthdown;
                 tmpdouble=tmpdouble/(1024*1024);
                 testat->append(QString("The Previous Month's Download :%1 MB")
                            .arg(tmpdouble,0,'f',2));
         }
         else
         {   tmpdouble=prevmonthdown;
             tmpdouble=tmpdouble/(1024*1024*1024);
             testat->append(QString("The Previous Month's Download :%1 GB")
                            .arg(tmpdouble,0,'f',2));
         }
         if(((monthdown+sessdown)/(1024*1024))<=999)
         {
             tmpdouble=monthdown+sessdown;
             tmpdouble=tmpdouble/(1024*1024);
             testat->append(QString("This Month's Download :%1 MB")
                                    .arg(tmpdouble, 0,'f',2));
         }
         else
             {
             tmpdouble=monthdown+sessdown;
             tmpdouble=tmpdouble/(1024*1024*1024);
             testat->append(QString("This Month's Download :%1 GB")
                            .arg(tmpdouble,0,'f',2));
             }
        testat->append(QString("The Last Sessions's Download :%1 MB")
                            .arg(((lastsess)/(1024*1024)), 0, 10));
}
