/*  This file is a part of the program DNetStats.
    DNetStats a linux qt application to monitor network and initiate 
    autoshutdown when connection is cut or idle.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/


#ifndef DIALOGIMPL_H
#define DIALOGIMPL_H

#include "ui_dialog.h"
# include "thread.h"
#include "shutthread.h"
//#include "ntmap.h"

 #include "netthread.h"
//
class DialogImpl : public QDialog, public Ui::Dialog
{
Q_OBJECT
public:
	DialogImpl( QWidget * parent = 0, Qt::WFlags f = 0);
	// 
	

	
protected:
    void closeEvent(QCloseEvent *event);
private:
    QString countstr,sstr,traystr,processstr,shutreason;
        //QTime ctime;
         //NtMapDialog *ndialog;

         QMessageBox msgBox,msg2Box,msg3Box;//message box to show shutdown
         QDateTime ctime; //shutdown time
         QDate cdate;
        char buf[25];
      unsigned long buf1,buf2,ubuf1,ubuf2,i,ucspeed,ret,ret2;
        fstream f;
        QGraphicsScene scene;
        QFont mfont;
        QLineF line1,line2,line3,line4,line5;
        int x1,y1,x2,y2,fpos;
        void gviewshow();
        QString spdstring,pathstr,lastsessmonth;

        bool ok,systraymsg,ishidden,shutinit,startflag;

    //
    Thread threadA;
    shutthread sthread;
    int idlecounter;
   unsigned long count,sysv,monthdown,totaldown,sessdown,prevmonthdown,nspeed;//idlecounter acts as counter for idle connection time
    double lvdown,vdown,rvdown,cspeed,tmpdouble;
    QSystemTrayIcon *trayicon;
	  QMenu *stmenu ;
	  QIcon icon;   
          QAction *startAction;
          QAction *stopAction;
          QAction *minimizeAction;
     QAction *maximizeAction;
     QAction *restoreAction;
     QAction *quitAction;
     void create_sys_tray();
     void create_msg_box();
     void get_log();
     void set_log();
     void show_stat();
//
       QStringList list;
       int row,column,rowcount;
       QTableWidgetItem *newItem;
       QTableWidgetItem * clickeditem;
       QList<QTableWidgetItem *> itemlist;
       netthread nthread;
     unsigned int lastsess;

private slots:

    void addClick();
    void addShut();
    void addExit();
    void addPkill();
    void chgconok();
    void chgconcut();

    void addSave();
    void addReset();
    void addResetCount();
    void initshut(QString);
    void itemclicked(QTableWidgetItem * );
    //void iconActivated(QSystemTrayIcon::ActivationReason reason);
    void tray_icon_click(QSystemTrayIcon::ActivationReason areason);
    void tabactive(int);
    //
    void ntmap_refresh(const QStringList list);
        void fileendslot();


    
    


};
#endif




